//PIN V1.21, 20.02.2006
//von Johannes Hogrefe
//(johannes_hogrefe@web.de)

#define USE_TI92PLUS  //Kompilieren fr TI92(PLUS)
#define USE_V200  //Kompilieren fr TI Voyage 200

#define MIN_AMS 205  //Programm bentigt AMS-Version 2.05 oder hher

#include <tigcclib.h>

void _main(void)
{
  LCD_BUFFER *lcd = HeapAllocPtr(sizeof(LCD_BUFFER));  //Reservieren des Speichers fr Bildschirmvariable
  LCD_save(lcd);  //Speichern des Bildschirms

  int tmp = 0;
  int key = 0;
	char pin_1[17];
	char pin_2[17];
	int i;
	
  clrscr();
  FontSetSys(F_6x8);
	
	FILE *fp;
	fp = fopen ("main\\pindata", "r");
	if(fp != NULL)  //Testen ob Variable 'pindata.PIN' vorhanden
	{
		for(i = 0; i < 17; i++)
		{
			pin_1[i] = fgetc(fp);
		}
		fclose(fp);
	}
	else
	{	
	  //Variable 'pindata.PIN' wird erstelltt
		fp = fopen ("main\\pindata", "wb");
		fputc (0, fp);
		fputc (0, fp);
		fputc (0, fp);
		for(i = 0; i < 17; i++)
		{
			fputc(pin_1[i], fp); 
		}
		fputc (0, fp);
		fputs ("PIN", fp);
		fputc (0, fp);
		fputc (OTH_TAG, fp);
		fclose (fp);
		
		//Eingabe des neuen PINs
    DrawClipRect(MakeWinRect(70,54,169,74),ScrRect,A_NORMAL);
    DrawLine(70,60,169,60,A_NORMAL);
	  FontSetSys(F_4x6);
	  printf_xy(71,55,"Neuer PIN:");
	  
		for(tmp = 0; tmp < 17; tmp++)
		  pin_1[tmp] = 0; 
		tmp = 0;
		do
		{
			key = ngetchx();
			if(key == 257 && tmp)
			{
				tmp--;
		    ScrRectFill (&(SCR_RECT){{tmp*6+71,65,tmp*6+76,71}}, ScrRect, A_REVERSE);
				pin_1[tmp] = 0;
			}
			if(key < 256 && key != 13 && key != 0 && tmp < 16)
			{
			  printf_xy(tmp*6+71,65,"*");
				pin_1[tmp] = key;
				tmp++;
			}
		} while(key != 13);
		
		//Speichern des neuen PINs in Variable 'pindata.PIN'
		fp = fopen ("main\\pindata", "wb");
		fputc (0, fp);
		fputc (0, fp);
		fputc (0, fp);
		for(i = 0; i < 21; i++)
		{
			fputc(pin_1[i], fp); 
		}
		fputc (0, fp);
		fputs ("PIN", fp);
		fputc (0, fp);
		fputc (OTH_TAG, fp);
		fclose (fp);
	}
	
	//Eingeben des PINs
	Main:
  clrscr();
	off();
	
  DrawClipRect(MakeWinRect(70,54,169,74),ScrRect,A_NORMAL);
  DrawLine(70,60,169,60,A_NORMAL);
	FontSetSys(F_4x6);
	printf_xy(71,55,"PIN eingabe:");
	
	for(tmp = 0; tmp < 17; tmp++)
	  pin_2[tmp] = 0; 
	tmp = 0;
	do
	{
		key = ngetchx();
		if(key == 257 && tmp)
		{
			tmp--;
		  ScrRectFill (&(SCR_RECT){{tmp*6+71,65,tmp*6+76,71}}, ScrRect, A_REVERSE);
			pin_2[tmp] = 0;
		}
		if(key < 256 && key != 13 && key != 0 && tmp < 16)
		{
			printf_xy(tmp*6+71,65,"*");
			pin_2[tmp] = key;
			tmp++;
		}
	} while(key != 13);
	
	//Prfen ob PINs identisch	
	for (i = 0; i < 17; i++)
	{
		if (pin_1[i] != pin_2[i])
		{ 
		  clrscr();
      DrawClipRect(MakeWinRect(70,54,169,74),ScrRect,A_NORMAL);
      DrawLine(70,60,169,60,A_NORMAL);
	    printf_xy(71,55,"Falscher PIN!");
	    printf_xy(71,65,"PIN bitte erneut eingeben!");
			ngetchx();
			goto Main;
		}
	}
	
	LCD_restore(lcd);  //Wiederherstellen des Bildschirms
	HeapFreePtr(lcd);  //Freigeben des Speichers fr Bildschirmvariable
  ST_helpMsg("PIN v1.21 von Johannes Hogrefe");
}
